!c Description:
!c   ɸ֤ˤ벽إݥƥ󥷥Υץå
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-02-20    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

subroutine plot_mu0
  use prm_common, only: property
  use prm_phys, only: pres_ref, temp_ref
  use interface_gibbs_energy

  implicit none
  integer                 :: i, iws, s, N
  integer, parameter      :: M = 10000
  real                    :: low(2)
  real                    :: high(2)
  real                    :: limit(2)
  real, allocatable       :: mu0_map(:,:)
  real, allocatable       :: temp_map(:)
  real(8)                 :: temp
  real(8)                 :: pres
  real(8)                 :: dt
  real(8), parameter      :: temp_low = 10.0d0
  real(8), parameter      :: temp_high = 1000.0d0
  real(8), allocatable    :: mu0(:)
  real(8), allocatable    :: mol(:)
  logical                 :: sw
  
  
!!!
!!!ѿν. ɸవϤǤ 1 mol Ǥͤץå. 
!!!
  N = size(property, 1)
  allocate(mu0_map(N, M), temp_map(M), mol(N))
  pres = pres_ref  
  mol = 1.0D0   !̤׻

  
!!!
!!!Ǯη׻
!!!
  mu0_map = 0.0D0; temp_map = 0.0D0
  dt = (temp_high - temp_low) / (M - 1)

  do i = 1, M
     temp = temp_low + (i - 1) * dt
     
     call gibbs_energy(temp, pres, mol, property, mu0=mu0)

     temp_map(i) = real(temp, 4)
     mu0_map(:,i) = real(mu0, 4)

     deallocate(mu0)
  end do


!!!
!!!դΥץ
!!!
  write(*,*) "workstation ID (i) ?"
  call sgpwsn
  read(*,*) iws
  call sglset('LCORNER', .FALSE.)
  call swiset('IWIDTH', 600)
  call swiset('IHEIGHT', 600)
  call gropn(iws)
  call slmgn(0.05, 0.05, 0.01, 0.01)
  
  
!!!  
!!! պ
!!!
  plot: do s = 1, N
     sw = property(s)%method == 3 &
          & .OR. property(s)%method == 4 .OR. property(s)%method == 5
     
     low(1) = real(property(s)%svap_cef%low%temp,4)
     low(2) = real(property(s)%svap_cef%low%temp,4) + dt
     high(1) = real(property(s)%svap_cef%high%temp,4)
     high(2) = real(property(s)%svap_cef%high%temp,4) + dt
     limit(1) = minval(mu0_map(s,:)) 
     limit(2) = maxval(mu0_map(s,:)) 
     
     call grfrm
     call usspnt(M, temp_map, mu0_map(s, :))
     if(sw) call usspnt(2, low, limit)
     if(sw) call usspnt(2, high, limit)
     
     call grstrn(1)
     call uspfit
     call grstrf
     call ussttl('Temperature', 'K', 'Entropy', 'J/ K mol')
     call usdaxs
     
     call sgspli(25)
     call sgplu(M, temp_map, mu0_map(s, :))
     if(sw) call sgspli(41)
     if(sw) call sgplu(2, low, limit)
     if(sw) call sgspli(41)
     if(sw) call sgplu(2, high, limit)
     
     call uxsttl('T', trim(property(s)%name), 0.0)
  end do plot
  
  
!!!
!!!դΥ
!!!
  call grcls

end subroutine Plot_mu0

