!c Description:
!c   ƲؼΥǡ١ե뤿Υץ 
!c   ʪǡ netCDF եϤ. 
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-02-14    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

program obrdata
  use netcdf
  use interface_netcdf_def
  use interface_netcdf_put
  use interface_netcdf_open
  use interface_netcdf_close
  use interface_mol2atm
  use interface_atm2wt
  use prm_chem, only: ChemInfo

  implicit none
  character(40)           :: name               !ѿ̾ 
  character(80)           :: long_name          !long_name °
  character(40)           :: units              !units °
  character(40)           :: file
  real(8)                 :: molwt
  real(8)                 :: rvar1
  real(8)                 :: rvar2
  real(8)                 :: rvar3(100, 2)
  real(8)                 :: rvar4(5)
  real(8), allocatable    :: rvar5(:,:)
  real(8), aLlocatable    :: enum(:)
  integer                 :: ivar1
  integer                 :: ivar2
  integer, allocatable    :: atmnum(:)
  character(5)            :: temp_unit
  character(5)            :: svap_unit
  character(40)           :: cvar

  integer                 :: status 
  integer                 :: num  
  integer                 :: len
  integer                 :: ncid               !ե ID
  integer                 :: spcid              ! ID
  integer                 :: elmid              ! ID
  integer                 :: tempid             ! ID
  integer                 :: cef5id             ! ID


!!!
!!!ǡƤӽФ(ȷ⥸塼Υ֥롼ƤӽФ)
!!!
  call ChemInfo


!!!
!!!ե
!!!
  write(*,*) "ؼ̾ϤƲ. (: H2O-g)"
  read(*,*) file
  file = trim(file) // '.nc'
  write(*,*) "creating data file ", trim(file)

  !ե
  call netcdf_create(file, ncid)

!!!
!!!ؼ˴ޤޤ븵Ǥθֹ, Ŀ, ʬ̤׻
!!!
  name = file(1:len_trim(file)-5)
  call mol2atm(name, atmnum, enum) 
  call atm2wt(atmnum, enum, molwt)


!!!
!!!
!!!
  !ؼ뼡 spc 
  name = "spc"
  len = 1
  call netcdf_def(ncid, name, len, spcid)

  !Ǥ뼡
  name = "atmnum"
  len = size(atmnum, 1)
  call netcdf_def(ncid, name, len, elmid)

  !٤뼡
  name = "temp"
  len = nf90_unlimited
  call netcdf_def(ncid, name, len, tempid)

  !˰¾ηݴɤ뤿μ
  name = "cef5"
  len = 5
  call netcdf_def(ncid, name, len, cef5id)


!!!
!!!ѿ
!!!
  !ʬΨ
  name = "molwt"
  long_name = "molecular weight"
  units = "g/mol"
  call netcdf_def(ncid, name, long_name, units, nf90_double, spcid)
  
!  !ɸಹ٤
!  name = "temp_ref"
!  long_name = "reference temperature"
!  units = "K"
!  call netcdf_def(ncid, name, long_name, units, nf90_double, spcid)
  
!  !ɸవϤ
!  name = "pres_ref"
!  long_name = "reference pressure"
!  units = "Pa"
!  call netcdf_def(ncid, name, long_name, units, nf90_double, spcid)
  
  !ɸ२ȥԡ
  name = "entr_ref"
  long_name = "reference entropy"
  units = "J/ K kg"
  call netcdf_def(ncid, name, long_name, units, nf90_double, spcid)
  
  !ɸ२󥿥ԡ
  name = "enth_ref"
  long_name = "reference enthalpy"
  units = "J/ K kg"
  call netcdf_def(ncid, name, long_name, units, nf90_double, spcid)
  
  !ϱդΥå
  name = "solsw"
  long_name = "solution switch"
  units = "1"
  call netcdf_def(ncid, name, long_name, units, nf90_int, spcid)
  
  !׻ˡ򼨤å
  name = "method"
  long_name = "calculation method for chemical potential"
  units = "1"
  call netcdf_def(ncid, name, long_name, units, nf90_int, spcid)

  !ֹ
  name = "atmnum"
  long_name = "atomic number"
  units = "1"
  call netcdf_def(ncid, name, long_name, units, nf90_int, elmid)

  !ǿ
  name = "enum"
  long_name = "number of element in the chemical spece"
  units = "1"
  call netcdf_def(ncid, name, long_name, units, nf90_double, elmid)

  !
  name = "temp"
  long_name = "temperature"
  units = "K"
  call netcdf_def(ncid, name, long_name, units, nf90_double, tempid)

  !Ǯ
  name = "cp"
  long_name = "specific heat"
  units = "J/ K mol"
  call netcdf_def(ncid, name, long_name, units, nf90_double, tempid)

  !˰¾
  name = "svap"
  long_name = "saturated vaper pressure"
  units = "Pa"
  call netcdf_def(ncid, name, long_name, units, nf90_double, tempid)

  !˰¾η
  name = "amp"
  long_name = "coefficients for the equation of saturated vaper pressure"
  units = "1"
  call netcdf_def(ncid, name, long_name, units, nf90_double, cef5id)

  !˰¾η
  name = "antoine"
  long_name = "coefficients for the equation of saturated vaper pressure"
  units = "1"
  call netcdf_def(ncid, name, long_name, units, nf90_double, cef5id)


!!!
!!!Х°
!!!
  status = nf90_put_att(ncid, nf90_global, "title", "thermodynamical properties for chemical spece")
  status = nf90_put_att(ncid, nf90_global, "institution", "GFD_Dennou_Club oboro Project")
  call fdate(name)
  status = nf90_put_att(ncid, nf90_global, "history", name)


!!!  
!!!⡼ɽλ
!!!
  call netcdf_enddef(ncid)


!!!
!!!ɲ( 1). 顼
!!!  
  !ʬ̤. ͤϲؼ̾Ƚ.  
  name = "molwt"
  call netcdf_put(ncid, name, molwt)


  !ֹ. 
  name = "atmnum"
  call netcdf_put(ncid, name, atmnum)


  !ǿ. 
  name = "enum"
  call netcdf_put(ncid, name, enum)


!  !ɸಹ٤. 
!  write(*,*) "ɸಹ٤򤷤Ʋ"
!  write(*,*) "   1. 298.15 [K]"
!  write(*,*) "   2. 298.15 [K] ʳ"
!  read(*,*) ivar1
!  if (ivar1 /= 1 .AND. ivar1 /= 2) then 
!     write(*,*) "򤵤줿ֹ椬ְäƤޤ"
!     stop
!  elseif (ivar1 == 1) then 
!     rvar1 = 298.15d0
!  elseif (ivar1 == 2) then 
!     write(*,*) "ɸಹ٤ϤƲ. ñ̤ K (ӥ)."
!     read(*,*) rvar1
!  end if
!  name = "temp_ref"
!  call netcdf_put(ncid, name, rvar1)


!  !ɸవϤ. 
!  write(*,*) "ɸవϤ򤷤Ʋ"
!  write(*,*) "   1. 100,000 [Pa]"
!  write(*,*) "   2. 100.000 [Pa] ʳ"
!  read(*,*) ivar1
!  if (ivar1 /= 1 .AND. ivar1 /= 2) then 
!     write(*,*) "򤵤줿ֹ椬ְäƤޤ"
!     stop
!  elseif (ivar1 == 1) then 
!     rvar1 = 1.0d5
!  elseif (ivar1 == 2) then 
!     write(*,*) "ɸవϤϤƲ. ñ̤ Pa (ѥ)."
!     read(*,*) rvar1
!  end if
!  name = "pres_ref"
!  call netcdf_put(ncid, name, rvar1)


  !ɸ֤ǤΥȥԡ. 
  write(*,*) "ɸ֤ǤΥȥԡϤƲ. ñ̤ J/ K mol."
  write(*,*) "إݥƥ󥷥׻ͤ 0 Ǥ OK."
  read(*,*) rvar1
  name = "entr_ref"
  call netcdf_put(ncid, name, rvar1)


  !ɸ֤ǤΥ󥿥ԡ. 
  write(*,*) "ɸ֤ǤΥ󥿥ԡϤƲ. ñ̤ J/ K mol."
  read(*,*) rvar1
  name = "enth_ref"
  call netcdf_put(ncid, name, rvar1)


  !ϱդΥå
  write(*,*) "ʪϿϱդޤ? [y/n]"
  read(*,*) cvar
  if (trim(cvar) /= "y" .AND.  trim(cvar) /= "n") then 
     write(*,*) "򤵤Ƥޤ"
     stop
  elseif (trim(cvar) == "y") then 
     ivar1 = 1
  elseif (trim(cvar) == "n") then 
     ivar1 = 0
  end if
  name = "solsw"  
  call netcdf_put(ncid, name, ivar1)


  !׻ˡ򼨤å
  write(*,*) "إݥƥ󥷥׻ˡ򤷤Ʋ."
  write(*,*) "  1. "
  write(*,*) "  2. Ǯ򥹥ץ饤֤Ʒ׻"
  write(*,*) "  3. ˰¾׻. ּ AMP ˡ"
  write(*,*) "  4. ˰¾׻. ּ Antoine ˡ(SI ñ̷)"
  write(*,*) "  5. NH4SH(s) ʿ׻"
  read(*,*) ivar2
  if (ivar2 /= 1 .AND. ivar2 /= 2 .AND. ivar2 /= 3 &
       & .AND. ivar2 /= 4 .AND. ivar2 /= 5 .AND. ivar2 /= 6) then 
     write(*,*) "򤵤Ƥޤ"
     stop
  end if
  name = "method"
  call netcdf_put(ncid, name, ivar2)


  !٤Ǯδط
  if (ivar2 == 2) then 
     write(*,*) ", ǮνǮβٰ¸ϤƲ. "
     write(*,*) "100K  200 J/K mol ʤ 100 200 ϤƲ. "
     write(*,*) "Ϥλ Ctl-d ǥȥåפƲ. "
     num = 1
     input_cp: do 
        read(*,*, iostat = status) rvar1, rvar2
        if (status /= 0) exit input_cp     
        
        rvar3(num, :) = (/rvar1, rvar2/) 
        num = num + 1     
     end do input_cp
     
     write(*,*) "ǮϽλ"
     num = minloc(rvar3(:,1), 1)
     allocate(rvar5(num-1, 2))
     rvar5(:,1) = pack(rvar3(:,1), rvar3(:,1) /= 0.0d0)
     rvar5(:,2) = pack(rvar3(:,2), rvar3(:,2) /= 0.0d0)

     name = "temp"
     call netcdf_put(ncid, name, rvar5(:,1))
     name = "cp"
     call netcdf_put(ncid, name, rvar5(:,2))

  elseif (ivar2 == 3 .OR. ivar2 == 4 .OR. ivar2 == 5) then 

     !Ǯδط
     write(*,*) ""
     write(*,*) "  ٤ñ̤򤷤Ʋ"
     write(*,*) "    1. K (ӥ)"
     write(*,*) "    2. C (ݻ)"
     read(*,*) ivar1
     if (ivar1 == 1) then 
        temp_unit = "K"
     elseif(ivar1 == 2) then 
        temp_unit = "C"
     else
        write(*,*) "򤵤줿ñ̤¸ߤޤ"
     end if
     write(*,*) "  ñ̤?"
     write(*,*) "    1. Pa (ѥ)"
     write(*,*) "    2. mmHg ()"
     read(*,*) ivar1
     if (ivar1 == 1) then 
        temp_unit = "Pa"
     elseif(ivar1 == 2) then 
        svap_unit = "mmHg"
     else
        write(*,*) "򤵤줿ñ̤¸ߤޤ"
     end if

     write(*,*) ", ν˾βٰ¸ϤƲ. "
     write(*,*) "100K  200 J/K mol ʤ 100 200 ϤƲ. "
     write(*,*) "Ϥλ Ctl-d ǥȥåפƲ. "
     num = 1
     input_svap: do 
        read(*,*, iostat = status) rvar1, rvar2
        if (status /= 0) exit input_svap

        call convertunits(temp_unit, rvar1)
        call convertunits(svap_unit, rvar2)

        rvar3(num, :) = (/rvar1, rvar2/) 

        num = num + 1     
     end do input_svap
     
     write(*,*) "Ͻλ"
     num = minloc(rvar3(:,1), 1)
     allocate(rvar5(num-1, 2))
     rvar5(:,1) = pack(rvar3(:,1), rvar3(:,1) /= 0.0d0)
     rvar5(:,2) = pack(rvar3(:,2), rvar3(:,2) /= 0.0d0)
     
     name = "temp"
     call netcdf_put(ncid, name, rvar5(:,1))
     name = "svap"
     call netcdf_put(ncid, name, rvar5(:,2))
  end if


  !˰¾η
  if (ivar2 == 3 .OR. ivar2 == 4 .OR. ivar2 == 5) then 
     write(*,*) "AMP ˡηϤޤ? [y/n]"
     read(*,*) cvar
     if (trim(cvar) == "y") then 
        rvar4 = 0.0d0
        write(*,*) "ϤƲ"
        read(*,*) rvar4(1), rvar4(2), rvar4(3), rvar4(4), rvar4(5) 
        name = "amp"
        call netcdf_put(ncid, name, rvar4)        
     end if

     write(*,*) "antoine ˡηϤޤ? [y/n]"
     read(*,*) cvar
     if (trim(cvar) == "y") then 
        rvar4 = 0.0d0
        write(*,*) "ϤƲ"
        read(*,*) rvar4(1), rvar4(2), rvar4(3)
        name = "antoine"
        call netcdf_put(ncid, name, rvar4)
     end if

  end if


!!!
!!!netCDF եΥ
!!!  
  call netcdf_close(ncid)


  
end program obrdata
